"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var paths_1 = require("../config/paths");
var mkdirp_1 = __importDefault(require("mkdirp"));
var utils_1 = require("../utils");
exports.prepareAssetFolder = function (outDir) {
    var destPath = path_1.default.resolve(utils_1.resolvePathInProject(outDir), paths_1.folders.assets);
    if (!fs_1.default.existsSync(destPath)) {
        // 低版本 node 会出现问题, zeit 的 8.x 就是
        // fs.mkdirSync(destPath, {
        //   recursive: true,
        // })
        mkdirp_1.default.sync(destPath);
    }
    return destPath;
};
/**
 * @param filePath absolute file path
 */
// TODO: add file hash
exports.copyFileToAssetFolder = function (filePath, outDir) {
    var folderPath = utils_1.resolvePathInProject(outDir, paths_1.folders.assets);
    var filename = utils_1.getFilename(filePath);
    var destFilePathAbs = path_1.default.resolve(folderPath, filename);
    fs_1.default.copyFileSync(filePath, destFilePathAbs);
    return destFilePathAbs;
};
//# sourceMappingURL=asset.js.map