"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var webpack_1 = __importDefault(require("webpack"));
var path_1 = __importDefault(require("path"));
var webpack_merge_1 = __importDefault(require("webpack-merge"));
var checkRequiredFiles_1 = __importDefault(require("react-dev-utils/checkRequiredFiles"));
var utils_1 = require("../utils");
var webpack_config_1 = __importDefault(require("../webpack.config"));
var entry_1 = require("./entry");
var asset_1 = require("./asset");
var defaultOptions = {
    outDir: 'build',
};
exports.initCompiler = function (options) {
    var _a = __assign({}, defaultOptions, options), configFilePath = _a.configFilePath, entryFilePath = _a.entryFilePath, webpackEnv = _a.webpackEnv, outDir = _a.outDir, rest = __rest(_a, ["configFilePath", "entryFilePath", "webpackEnv", "outDir"]);
    asset_1.prepareAssetFolder(outDir);
    // TODO: copy files from `public` to `outDir`
    // handleEntry 执行了很多 side effects，并不确信这么写会很好
    var _b = entry_1.handleEntry(entryFilePath, {
        outDir: outDir,
        webpackEnv: webpackEnv,
    }), htmlFilePathAbs = _b.htmlFilePathAbs, entry = _b.entry;
    // 用户指定的 webpack 配置文件
    var webpackConfig = {};
    if (configFilePath) {
        var configFilePathAbs = configFilePath;
        if (!path_1.default.isAbsolute(configFilePath)) {
            configFilePathAbs = utils_1.resolvePathInProject(configFilePath);
        }
        if (!checkRequiredFiles_1.default([configFilePathAbs])) {
            process.exit(1);
        }
        webpackConfig = require(configFilePathAbs);
        utils_1.print.log(configFilePathAbs + " is being used");
    }
    // 用户提供的 config 目前只能以高优先级合并，如果想完全替换默认的 config 暂不支持
    var finalWebpackConfig = webpack_merge_1.default(webpack_config_1.default(__assign({}, rest, { webpackEnv: webpackEnv,
        htmlFilePathAbs: htmlFilePathAbs,
        entry: entry,
        outDir: outDir })), webpackConfig);
    return {
        compiler: webpack_1.default(finalWebpackConfig),
        webpackConfig: finalWebpackConfig,
        outDir: outDir,
    };
};
//# sourceMappingURL=compiler.js.map