"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var utils_1 = require("../utils");
var html_1 = require("./html");
exports.handleEntry = function (entryFilePath, options) {
    var webpackEnv = options.webpackEnv, outDir = options.outDir;
    var isDevEnv = webpackEnv === 'development';
    var entryFilePathAbs = entryFilePath;
    if (!path_1.default.isAbsolute(entryFilePath)) {
        entryFilePathAbs = utils_1.resolvePathInProject(entryFilePath);
    }
    var htmlFilePathAbs;
    var webpackEntry;
    if (entryFilePathAbs.endsWith('.html')) {
        var _a = html_1.prepareHtmlFile({
            htmlPathAbs: entryFilePathAbs,
            outDir: outDir,
            isDevEnv: isDevEnv,
        }), htmlPath = _a.htmlPath, entry = _a.entry;
        if (!entry) {
            utils_1.print.warn("no entry was found in " + entryFilePathAbs);
        }
        htmlFilePathAbs = htmlPath;
        webpackEntry = entry;
    }
    else {
        webpackEntry = entryFilePathAbs;
    }
    return {
        htmlFilePathAbs: htmlFilePathAbs,
        entry: webpackEntry,
    };
};
//# sourceMappingURL=entry.js.map