"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var jsdom_1 = require("jsdom");
var fs_1 = __importDefault(require("fs"));
var utils_1 = require("../utils");
var paths_1 = require("../config/paths");
var asset_1 = require("./asset");
/**
 * @param htmlFilePath absolute file path
 */
// TODO: 支持 watch html 文件变化
exports.prepareHtmlFile = function (options) {
    var htmlPathAbs = options.htmlPathAbs, outDir = options.outDir;
    var filename = utils_1.getFilename(htmlPathAbs);
    var html = fs_1.default.readFileSync(htmlPathAbs, {
        encoding: 'utf8',
    });
    var dom = new jsdom_1.JSDOM(html);
    var entry = [];
    /**
     *
     * @param filename
     * @param fileContent
     * @returns absolute cache file path
     */
    var saveFileToOutDir = function (filename, fileContent) {
        var destDir = utils_1.resolvePathInProject(outDir);
        var filePath = path_1.default.resolve(destDir, filename);
        fs_1.default.writeFileSync(filePath, fileContent, {
            encoding: 'utf8',
        });
        return filePath;
    };
    if (htmlPathAbs) {
        var resolveFilePathInHtml_1 = function (relPath) {
            var htmlFolderPath = path_1.default.resolve(path_1.default.relative(utils_1.resolvePathInProject('.'), htmlPathAbs), '../');
            return utils_1.resolvePathInProject(path_1.default.resolve(htmlFolderPath, relPath));
        };
        var handleCopy_1 = function (attrName) { return function (node) {
            var src = node.getAttribute(attrName);
            if (src) {
                var filePath = resolveFilePathInHtml_1(src);
                var newFilePath = asset_1.copyFileToAssetFolder(filePath, outDir);
                var newFilename = utils_1.getFilename(newFilePath);
                // TODO: base path
                var newSrc = "/" + paths_1.folders.assets + "/" + newFilename;
                node.setAttribute(attrName, newSrc);
            }
        }; };
        // link, img 资源拷贝
        dom.window.document.querySelectorAll('body img').forEach(handleCopy_1('src'));
        dom.window.document.querySelectorAll('link').forEach(handleCopy_1('href'));
        // 获取 entry
        dom.window.document.querySelectorAll('body script').forEach(function (node) {
            var src = node.getAttribute('src');
            var useRaw = node.getAttribute('raw') !== null;
            if (src) {
                if (useRaw) {
                    node.removeAttribute('raw');
                    handleCopy_1('src')(node);
                    return;
                }
                var scriptSrc = resolveFilePathInHtml_1(src);
                entry.push(scriptSrc);
                dom.window.document.body.removeChild(node);
            }
        });
    }
    var html2 = dom.serialize();
    var generatedHtmlAbsPath = saveFileToOutDir(filename, html2);
    return {
        htmlPath: generatedHtmlAbsPath,
        entry: entry.length ? entry : null,
    };
};
//# sourceMappingURL=html.js.map