"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var fs_1 = __importDefault(require("fs"));
var Rx_1 = __importDefault(require("rxjs/Rx"));
var webpack_dev_server_1 = __importDefault(require("webpack-dev-server"));
var openBrowser_1 = __importDefault(require("react-dev-utils/openBrowser"));
var ForkTsCheckerWebpackPlugin_1 = __importDefault(require("react-dev-utils/ForkTsCheckerWebpackPlugin"));
var formatWebpackMessages_1 = __importDefault(require("react-dev-utils/formatWebpackMessages"));
var typescriptFormatter_1 = __importDefault(require("react-dev-utils/typescriptFormatter"));
var WebpackDevServerUtils_1 = require("react-dev-utils/WebpackDevServerUtils");
var getIP_1 = __importDefault(require("../utils/getIP"));
var helpers_1 = require("../helpers/helpers");
var webpackDevServer_config_1 = __importDefault(require("../webpackDevServer.config"));
var constants_1 = require("../constants");
var compiler_1 = require("../compiler/compiler");
var utils_1 = require("../utils");
var paths_1 = __importDefault(require("../config/paths"));
process.env.BABEL_ENV = 'development';
process.env.NODE_ENV = 'development';
var defaultConfig = {
    port: 4006,
    shouldOpenBrowser: false,
};
var serve = function (config) {
    var finalConfig = __assign({}, defaultConfig, lodash_1.default.pickBy(config, function (v) { return v !== undefined; }));
    var configFilePath = finalConfig.configFilePath, shouldOpenBrowser = finalConfig.shouldOpenBrowser, entryFilePath = finalConfig.entryFilePath;
    var useTypeScript = fs_1.default.existsSync(paths_1.default.appTsConfig);
    // default port or port defined by user
    var port0 = finalConfig.port;
    var startDevServer = function (_a) {
        var onChangeStart = _a.onChangeStart, onChangeComplete = _a.onChangeComplete, onChangeError = _a.onChangeError;
        return __awaiter(_this, void 0, void 0, function () {
            var port, isFirstCompile, _b, compiler, outDir, tsMessagesPromise, tsMessagesResolver, outDirAbs, proxySetting, proxyConfig, serverConfig, devServerInstance;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, WebpackDevServerUtils_1.choosePort(getIP_1.default(), port0)];
                    case 1:
                        port = _c.sent();
                        isFirstCompile = true;
                        _b = compiler_1.initCompiler({
                            webpackEnv: 'development',
                            configFilePath: configFilePath,
                            entryFilePath: entryFilePath,
                        }), compiler = _b.compiler, outDir = _b.outDir;
                        if (useTypeScript) {
                            compiler.hooks.beforeCompile.tap('beforeCompile', function () {
                                tsMessagesPromise = new Promise(function (resolve) {
                                    tsMessagesResolver = function (msgs) { return resolve(msgs); };
                                });
                            });
                            ForkTsCheckerWebpackPlugin_1.default.getCompilerHooks(compiler).receive.tap('afterTypeScriptCheck', function (diagnostics, lints) {
                                var allMsgs = diagnostics.concat(lints);
                                var format = function (message) {
                                    return message.file + "\n" + typescriptFormatter_1.default(message, true);
                                };
                                tsMessagesResolver({
                                    errors: allMsgs.filter(function (msg) { return msg.severity === 'error'; }).map(format),
                                    warnings: allMsgs
                                        .filter(function (msg) { return msg.severity === 'warning'; })
                                        .map(format),
                                });
                            });
                        }
                        compiler.hooks.done.tap('invalid', function () {
                            onChangeStart();
                        });
                        compiler.hooks.done.tap('done', function (stats) { return __awaiter(_this, void 0, void 0, function () {
                            var messages, formatedMessages, ip, serverAddr, networkAddr;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!stats.hasErrors()) return [3 /*break*/, 1];
                                        onChangeError(helpers_1.toErrorOutputString(stats));
                                        return [3 /*break*/, 4];
                                    case 1:
                                        if (!useTypeScript) return [3 /*break*/, 3];
                                        return [4 /*yield*/, tsMessagesPromise];
                                    case 2:
                                        messages = _a.sent();
                                        if (messages.errors.length || messages.warnings.length) {
                                            formatedMessages = formatWebpackMessages_1.default({
                                                errors: messages.errors,
                                                warnings: messages.warnings,
                                            });
                                            onChangeError(formatedMessages.errors.join('\n\n'));
                                            return [2 /*return*/];
                                        }
                                        _a.label = 3;
                                    case 3:
                                        ip = getIP_1.default();
                                        serverAddr = "http://localhost:" + port + "/";
                                        networkAddr = "http://" + ip + ":" + port + "/";
                                        onChangeComplete("\n  Local:     " + serverAddr + "\n  Network:   " + networkAddr + "\n");
                                        if (isFirstCompile) {
                                            isFirstCompile = false;
                                            if (shouldOpenBrowser) {
                                                openBrowser_1.default(serverAddr);
                                            }
                                        }
                                        _a.label = 4;
                                    case 4: return [2 /*return*/];
                                }
                            });
                        }); });
                        outDirAbs = utils_1.resolvePathInProject(outDir);
                        proxySetting = require(paths_1.default.appPackageJson).proxy;
                        proxyConfig = WebpackDevServerUtils_1.prepareProxy(proxySetting, outDirAbs);
                        serverConfig = webpackDevServer_config_1.default({
                            proxy: proxyConfig,
                            contentBase: [outDirAbs],
                        });
                        devServerInstance = new webpack_dev_server_1.default(compiler, serverConfig);
                        // Launch WebpackDevServer
                        devServerInstance.listen(port, function (err /* , result */) {
                            if (err) {
                                onChangeError(err);
                            }
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    return Rx_1.default.Observable.create(function (observer) {
        startDevServer({
            onChangeStart: function () {
                return observer.next({
                    type: constants_1.TASK_STATUS.CHANGE_START,
                });
            },
            onChangeComplete: function (output) {
                return observer.next({
                    type: constants_1.TASK_STATUS.CHANGE_COMPLETE,
                    payload: output,
                });
            },
            onChangeError: function (error) {
                return observer.next({
                    type: constants_1.TASK_STATUS.CHANGE_ERROR,
                    payload: error,
                    meta: {
                        useRed: false,
                    },
                });
            },
        });
    });
};
exports.default = serve;
//# sourceMappingURL=serve.js.map