"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var makePrintFn = function (colorFn) { return function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    if (colorFn) {
        return console.log.apply(console, args.map(function (arg) { return colorFn(arg); }));
    }
    return console.log.apply(console, args);
}; };
var print = {
    log: makePrintFn(),
    info: makePrintFn(chalk_1.default.cyan),
    warn: makePrintFn(chalk_1.default.yellow),
    error: makePrintFn(chalk_1.default.red),
};
exports.default = print;
//# sourceMappingURL=print.js.map