"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var paths_1 = __importDefault(require("./config/paths"));
/**
 * Webpack dev server config used by wparcel
 * docs can be found here https://webpack.js.org/configuration/dev-server/
 */
exports.default = (function (_a) {
    var _b = _a === void 0 ? {} : _a, contentBase = _b.contentBase, proxy = _b.proxy;
    return {
        compress: true,
        clientLogLevel: 'none',
        quiet: true,
        watchOptions: {
            ignored: /node_modules/,
            aggregateTimeout: 500,
        },
        historyApiFallback: {
            // Paths with dots should still use the history fallback.
            // See https://github.com/facebook/create-react-app/issues/387.
            disableDotRule: true,
        },
        // https://github.com/webpack/webpack-dev-server/releases/tag/v2.4.3
        disableHostCheck: true,
        // 越往后优先级越低
        contentBase: contentBase.concat([paths_1.default.appPublic]),
        // HMR
        hot: true,
        proxy: proxy,
        before: function (app, server) {
            if (fs_1.default.existsSync(paths_1.default.proxySetup)) {
                // This registers user provided middleware for proxy reasons
                require(paths_1.default.proxySetup)(app);
            }
        },
    };
});
//# sourceMappingURL=webpackDevServer.config.js.map